#include <piece.h>
#include <string.h>
#include <muslib.h>
#include "mus_com.h"

unsigned char vbuff[DISP_X * DISP_Y];

void pceAppInit(void){
  pceLCDDispStop();
  pceLCDSetBuffer(vbuff);
  memset(vbuff, 0, DISP_X * DISP_Y);
  pceLCDDispStart();

  pceCPUSetSpeed(CPU_SPEED_NORMAL);
  pceAppSetProcPeriod(50);
  pcePadSetTrigMode(PP_MODE_SINGLE);
  pceFontSetType(0x80);

  // 
  initialize();

  draw = TRUE;
  drawNext = FALSE;

  nextFunction = play;
}

void pceAppProc(int cnt){
  PCEPWRSTAT ps;
  int voltage;
  static int voltageOld = 0;

  pad = pcePadGet();

  nextFunction();

  // dd擾
  pcePowerGetStatus(&ps);
  voltage = ps.battvol / 10.0 + 0.5;

  // ddωʂXV
  if(voltage != voltageOld){
    voltageOld = voltage;
    draw = TRUE;
  }

  // KvȂƂ̂݉ʂXV
  if(draw){
    pceLCDTrans();
    draw = FALSE;
  }

  // PXebvɍXVꍇ
  if(drawNext){
    draw = TRUE;
    drawNext = FALSE;
  }
}

void pceAppExit(void){
  StopMusic();
}

int pceAppNotify(int type, int param){

  // X^[g{^ŃVXej[ɓȂ
  if(type == APPNF_SMSTART){
    return APPNR_REJECT;
  }
  else{
    return APPNR_ACCEPT;
  }
}
